Index: /palm/trunk/EXAMPLES/test_salsa/test_salsa_p3d
===================================================================
--- /palm/trunk/EXAMPLES/test_salsa/test_salsa_p3d	(revision 3467)
+++ /palm/trunk/EXAMPLES/test_salsa/test_salsa_p3d	(revision 3467)
@@ -0,0 +1,226 @@
+!-------------------------------------------------------------------------------
+!-- INITIALIZATION PARAMETER NAMELIST
+!   Documentation: https://palm.muk.uni-hannover.de/trac/wiki/doc/app/inipar
+!-------------------------------------------------------------------------------
+ &initialization_parameters
+
+!
+!-- Grid
+!------------------------------------------------------------------------------
+    nx                   = 19,
+    ny                   = 19,
+    nz                   = 22,
+
+    dx                   = 2.0,
+    dy                   = 2.0,
+    dz                   = 2.0,
+
+!
+!-- Numerics
+!------------------------------------------------------------------------------
+    psolver              = 'multigrid',
+    momentum_advec       = 'ws-scheme',  ! default advection scheme
+    scalar_advec         = 'ws-scheme', 
+    conserve_volume_flow = .T.,
+
+!
+!-- Mode
+!------------------------------------------------------------------------------     
+    humidity             = .T.,
+    q_surface            = 0.008,
+
+!
+!-- Initialization
+!------------------------------------------------------------------------------
+    initializing_actions = 'set_constant_profiles',
+
+    pt_surface           = 293.15,
+    ug_surface           = 1.0,
+    vg_surface           = 0.0,
+
+    roughness_length     = 0.05,
+    neutral              = .T.,
+    
+    day_of_year_init     =  65,          ! March 06, to avoid extreme temperatures
+    time_utc_init        = 0.0,
+
+!
+!-- Boundary conditions
+!------------------------------------------------------------------------------ 
+    bc_lr                = 'cyclic', 
+    bc_ns                = 'cyclic',
+    bc_uv_t              = 'dirichlet',  ! channel flow boundary condition
+
+!
+!-- Topography
+!------------------------------------------------------------------------------    
+    topography           = 'read_from_file',
+
+!
+!-- Physics
+!------------------------------------------------------------------------------
+    longitude            = 13.4,         ! Berlin longitude
+    latitude             = 52.5,         ! Berlin latitude
+      
+ / ! end of inipar namelist
+
+
+!-------------------------------------------------------------------------------
+!-- RUNTIME PARAMETER NAMELIST
+!   Documentation: https://palm.muk.uni-hannover.de/trac/wiki/doc/app/d3par
+!-------------------------------------------------------------------------------
+ &runtime_parameters
+
+!
+!-- Run steering
+!------------------------------------------------------------------------------
+    end_time              = 1000.0,
+    create_disturbances   = .T.,
+
+!
+!-- General output settings
+!------------------------------------------------------------------------------
+    netcdf_data_format    = 4,           ! use NetCDF4
+
+!
+!-- Run-control/timeseries output settings
+!------------------------------------------------------------------------------
+    dt_run_control        =  0.0,
+    dt_dots               =  0.0,
+
+!
+!-- Profile output settings
+!------------------------------------------------------------------------------
+    skip_time_dopr        =   0.0,
+    dt_dopr               = 500.0,
+    averaging_interval_pr = 500.0,
+    dt_averaging_input_pr =   0.0,
+
+    data_output_pr        = '#u',  'u*2',  'wu',  'w*u*',  'w"u"',
+                            '#v',  'v*2',  'wv',  'w*v*',  'w"v"',
+                            'w',   'w*2',
+                            '#pt', 'pt*2', 'wpt', 'w*pt*', 'w"pt"',
+                            'e', 'e*', '#km', '#l',
+!
+!-- 2D/3D output settings
+!------------------------------------------------------------------------------
+    do3d_at_begin      = .T., 
+    do2d_at_begin      = .T.,
+
+    dt_data_output     = 50.0,
+
+
+    data_output = 'u', 'v', 'w',
+                  'Ntot', 'LDSA', 'PM2.5', 
+                  's_SO4', 's_OC', 's_BC', 's_NH', 's_NO',
+                  'g_H2SO4','g_HNO3','g_NH3','g_OCNV','g_OCSV',
+                  'N_bin1', 'N_bin2', 'N_bin3', 'N_bin4', 'N_bin5', 
+                  'N_bin6', 'N_bin7', 'N_bin8', 'N_bin9', 'N_bin10',
+
+ / ! end of d3par namelist
+
+
+!-------------------------------------------------------------------------------
+!-- PLANT CANOPY MODEL PARAMETER NAMELIST
+!   Documentation: https://palm.muk.uni-hannover.de/trac/wiki/doc/app/canpar
+!-------------------------------------------------------------------------------
+ &plant_canopy_parameters
+ 
+    canopy_mode       = 'read_from_file_3d',
+    canopy_drag_coeff = 0.5,
+      
+ / ! end of canopy_par namelist
+
+
+!-------------------------------------------------------------------------------
+!-- SALSA PARAMETER NAMELIST
+!-------------------------------------------------------------------------------
+ &salsa_parameters  
+
+!
+!-- Time stepping
+    dt_salsa           =   4.0, ! time step for calculating aerosol processes (s)
+    skip_time_do_salsa = 100.0, ! starting time of SALSA (s)
+
+!
+!-- Concentration initial types: 0 = based on the parameter file, 1 = read from a NetCDF file
+    isdtyp    = 1, ! size distribution
+    igctyp    = 1, ! gases
+
+!
+!-- If isdtyp = 0, define the initial aerosol size distribution by dpg, sigmag and n_lognorm
+ !   dpg       = 0.01347865, 0.05400739, 0.86411863, ! mean diameter per mode (micrometres)
+ !   sigmag    =        1.8,       2.16,       2.21, ! standard deviation per mode 
+ !   n_lognorm =     1434.0,      445.9,      0.07,  ! number concentration per mode (#/cm3)
+
+!
+!-- If igctyp = 0, apply these initial gas concentrations			
+ !   H2SO4_init = 5.0E12, ! sulphuric acid (#/m3)
+ !   HNO3_init  = 3.0E15, ! nitric acid (#/m3)
+ !   NH3_init   = 6.0E15, ! ammonia (#/m3)        
+ !   OCNV_init  = 1.0E14, ! non-volatile organic gases (#/m3)
+ !   OCSV_init  = 1.0E14, ! non-volatile organic gases (#/m3)
+
+!
+!-- List of activated chemical components: 
+!-- NOTE! Chemical species have to be activated here even if they are not initially present!
+    listspec = 'SO4','OC','BC','NH','NO','','',  ! List of actived aerosols        
+    ! listspec = 'SO4','OC','BC','DU','SS','NO','NH', 
+
+!
+!-- If isdtyp = 0, set the chemical composition of the initial particle size distribution
+ !   mass_fracs_a = 0.1, 0.4, 0.3, 0.1, 0.1, 0.0, 0.0, ! mass fractions of chemical components: soluble 
+ !   mass_fracs_b = 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, ! mass fractions of chemical components: insoluble
+!-- NOTE! Set everyhing to zero in mass_fracs_b if you do not want include insoluble species (default)
+
+!
+!-- Sectional presentation of the particle size distribution
+    reglim = 3.0E-9, 5.0E-8, 2.5E-6, ! limits of the subranges (m)
+    nbin   = 3, 7,                   ! number of bins per subrange 
+!-- NOTE! Subrange 1 consists only of H2SO4 and/or OC
+    nf2a   = 1.0,	             ! Number fraction allocated to subrange 2a (b-bins will get 1-nf2a) 
+
+!
+!-- Aerosol emissions:
+    salsa_source_mode = 'read_from_file', 
+!-- NOTE! chemical components of the source have to be activated in 'listspec'
+
+!
+!-- Boundary conditions
+!-- Decycle at the left & right boundaries: initial concentration  
+!--   is copied to ghost and first three layers at both boundaries at the left boundary
+!--   and a zero gradient is set at the right boundary
+!-- Decycle at the north & south boundaries: initial concentration  
+!--   is copied to ghost and first three layers at both boundaries
+    decycle_lr     = .T.,         
+    decycle_ns     = .F.,
+    decycle_method = 'dirichlet','dirichlet','dirichlet','dirichlet',  
+    bc_salsa_b     = 'neumann', !'dirichlet',  ! surface flux requires 'neumann'
+    bc_salsa_t     = 'dirichlet',  ! top
+											   
+!
+!-- Switches for aerosol processes:
+    nldistupdate = .T.,
+    nldepo       = .T., ! Deposition master switch
+    nldepo_vege  = .T., ! Deposition on vegetation
+    nldepo_topo  = .T., ! Deposition on walls
+    nlcnd        = .T., ! Condensation master switch
+    nlcndgas     = .T., ! Condensation of precursor gases
+    nlcndh2oae   = .F., ! Condensation of H2O on aerosols                          
+    nlcoag       = .T., ! Coagulation master switch
+    nsnucl       =  1,  ! Nucleation scheme (0 = off)
+    nj3          =  1,  ! J3 parametrization for nucleation 
+
+    depo_vege_type = 'zhang2001',
+    depo_topo_type = 'zhang2001',
+
+!
+!-- Other switches:
+    advect_particle_water   = .T.,   ! particle water: advect or calculate at each dt_salsa 
+    feedback_to_palm        = .F.,   ! feedback to flow due to condensation of water
+    read_restart_data_salsa = .F.,   ! skip reading restart data even if it's done for the flow
+    write_binary_salsa      = .F.,   ! skip writing restart data even if it's done for the flow
+         
+ / ! end of salsa_par namelist
+
+ 
Index: /palm/trunk/SCRIPTS/.palm.iofiles
===================================================================
--- /palm/trunk/SCRIPTS/.palm.iofiles	(revision 3466)
+++ /palm/trunk/SCRIPTS/.palm.iofiles	(revision 3467)
@@ -11,4 +11,6 @@
 PIDS_STATIC              inopt:tr   d3#:d3r  $base_data/$run_identifier/INPUT          _static*
 PIDS_DYNAMIC             inopt:tr   d3#:d3r  $base_data/$run_identifier/INPUT          _dynamic*
+PIDS_SALSA               inopt:tr   d3#:d3r  $base_data/$run_identifier/INPUT          _salsa*
+PIDS_CHEM                inopt:tr   d3#:d3r  $base_data/$run_identifier/INPUT          _chemistry*
 rrtmg_lw.nc              inopt:tr   d3#:d3r  $base_data/$run_identifier/INPUT          _rlw
 rrtmg_sw.nc              inopt:tr   d3#:d3r  $base_data/$run_identifier/INPUT          _rsw
Index: /palm/trunk/SOURCE/Makefile
===================================================================
--- /palm/trunk/SOURCE/Makefile	(revision 3466)
+++ /palm/trunk/SOURCE/Makefile	(revision 3467)
@@ -25,4 +25,8 @@
 # -----------------
 # $Id$
+# Implementation of a new aerosol module salsa.
+# 
+# 
+# 3458 2018-10-30 14:51:23Z kanani
 # from chemistry branch r3443, banzhafs, Russo, forkel, basit:
 # radiation_model_mod added to chemistry_model_mod
@@ -628,4 +632,6 @@
 	read_restart_data_mod.f90 \
 	run_control.f90 \
+	salsa_mod.f90 \
+	salsa_util_mod.f90 \
 	set_slicer_attributes_dvrp.f90 \
 	singleton_mod.f90 \
@@ -693,5 +699,5 @@
 
 CC = cc
-CFLAGS = -O
+CFLAGS = -O 
 
 F90 =
@@ -703,5 +709,4 @@
 # The following line is needed for palm_simple_install, don't remove it!
 #to_be_replaced_by_include
-
 
 .SUFFIXES:
@@ -746,5 +751,6 @@
 	bulk_cloud_model_mod.o \
 	mod_kinds.o \
-	modules.o
+	modules.o \
+        salsa_util_mod.o
 advec_w_pw.o: \
 	mod_kinds.o \
@@ -765,4 +771,5 @@
 	ocean_mod.o \
 	radiation_model_mod.o \
+	salsa_mod.o \
 	turbulence_closure_mod.o \
 	urban_surface_mod.o
@@ -793,4 +800,5 @@
 	modules.o \
 	pmc_interface_mod.o \
+	salsa_mod.o \
 	surface_mod.o \
 	turbulence_closure_mod.o
@@ -837,4 +845,5 @@
 	pmc_interface_mod.o \
 	radiation_model_mod.o \
+	salsa_mod.o \
 	spectra_mod.o \
 	subsidence_mod.o \
@@ -853,4 +862,5 @@
 	modules.o \
 	netcdf_data_input_mod.o \
+	salsa_mod.o \
 	surface_mod.o
 chemistry_model_mod.o: \
@@ -916,4 +926,5 @@
 	modules.o \
 	netcdf_interface_mod.o \
+	salsa_mod.o \
 	surface_mod.o
 data_output_profiles.o: \
@@ -960,4 +971,5 @@
 	ocean_mod.o \
 	radiation_model_mod.o \
+	salsa_mod.o \
 	surface_mod.o \
 	urban_surface_mod.o \
@@ -976,4 +988,5 @@
 	netcdf_interface_mod.o \
 	ocean_mod.o \
+	salsa_mod.o \
 	turbulence_closure_mod.o \
 	urban_surface_mod.o
@@ -1062,4 +1075,5 @@
 	pmc_interface_mod.o \
 	radiation_model_mod.o \
+	salsa_mod.o \
 	spectra_mod.o \
 	subsidence_mod.o \
@@ -1097,4 +1111,5 @@
 	random_generator_parallel_mod.o \
 	read_restart_data_mod.o \
+	salsa_mod.o \
 	surface_layer_fluxes_mod.o \
 	surface_mod.o \
@@ -1131,5 +1146,6 @@
 	modules.o \
 	netcdf_interface_mod.o \
-	radiation_model_mod.o
+	radiation_model_mod.o \
+	salsa_mod.o
 init_pegrid.o: \
 	mod_kinds.o \
@@ -1343,4 +1359,5 @@
 	ocean_mod.o \
 	radiation_model_mod.o \
+	salsa_mod.o \
 	spectra_mod.o \
 	turbulence_closure_mod.o \
@@ -1386,4 +1403,5 @@
 	pmc_interface_mod.o \
 	pmc_particle_interface.o \
+	salsa_mod.o \
 	surface_layer_fluxes_mod.o \
 	time_to_string.o \
@@ -1410,4 +1428,5 @@
 	radiation_model_mod.o \
 	read_restart_data_mod.o \
+	salsa_mod.o \
 	spectra_mod.o \
 	surface_output_mod.o \
@@ -1444,4 +1463,5 @@
 	pmc_mpi_wrapper_mod.o \
 	pmc_parent_mod.o \
+	salsa_mod.o \
 	surface_mod.o
 pmc_child_mod.o: \
@@ -1522,4 +1542,5 @@
 	plant_canopy_model_mod.o \
 	radiation_model_mod.o \
+	salsa_mod.o \
 	subsidence_mod.o \
 	surface_mod.o \
@@ -1564,4 +1585,5 @@
 	random_function_mod.o\
 	random_generator_parallel_mod.o \
+	salsa_mod.o \
 	spectra_mod.o \
 	surface_mod.o \
@@ -1576,4 +1598,20 @@
 	mod_kinds.o \
 	modules.o
+salsa_mod.o: \
+	modules.o \
+	mod_kinds.o \
+	advec_ws.o \
+	advec_s_pw.o \
+	advec_s_up.o \
+        chemistry_model_mod.o \
+	diffusion_s.o \
+	netcdf_data_input_mod.o \
+	plant_canopy_model_mod.o \
+	salsa_util_mod.o \
+	surface_mod.o \
+	netcdf_data_input_mod.o
+salsa_util_mod.o: \
+	mod_kinds.o \
+	modules.o
 set_slicer_attributes_dvrp.o: \
 	mod_kinds.o \
@@ -1603,4 +1641,5 @@
 	modules.o \
 	radiation_model_mod.o \
+	salsa_mod.o \
 	surface_mod.o \
 	turbulence_closure_mod.o \
@@ -1642,4 +1681,5 @@
 	ocean_mod.o \
 	pmc_interface_mod.o \
+	salsa_mod.o \
 	turbulence_closure_mod.o \
 	urban_surface_mod.o
@@ -1681,4 +1721,5 @@
 	progress_bar_mod.o \
 	radiation_model_mod.o \
+	salsa_mod.o \
 	spectra_mod.o \
 	surface_layer_fluxes_mod.o \
Index: /palm/trunk/SOURCE/advec_ws.f90
===================================================================
--- /palm/trunk/SOURCE/advec_ws.f90	(revision 3466)
+++ /palm/trunk/SOURCE/advec_ws.f90	(revision 3467)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Implementation of a new aerosol module salsa.
+! 
+! 3302 2018-10-03 02:39:40Z raasch
 ! Stokes drift velocity added in scalar advection
 ! 
@@ -47,5 +50,5 @@
 ! 2731 2018-01-09 17:44:02Z suehring
 ! Enable loop vectorization by splitting the k-loop
-! 
+!
 ! 2718 2018-01-02 08:49:38Z maronga
 ! Corrected "Former revisions" section
@@ -315,4 +318,7 @@
        USE pegrid
 
+       USE salsa_util_mod,                                                     &
+           ONLY:  sums_salsa_ws_l   
+       
        USE statistics,                                                         &
            ONLY:  sums_us2_ws_l, sums_vs2_ws_l, sums_ws2_ws_l, sums_wsncs_ws_l,& 
@@ -381,5 +387,9 @@
              ALLOCATE( sums_wssas_ws_l(nzb:nzt+1,0:threads_per_task-1) )
              sums_wssas_ws_l = 0.0_wp
-          ENDIF
+          ENDIF        
+!          
+!--       Mona: Now always allocated
+          ALLOCATE( sums_salsa_ws_l(nzb:nzt+1,0:threads_per_task-1) )
+          sums_salsa_ws_l = 0.0_wp         
 
        ENDIF
@@ -1096,14 +1106,17 @@
                   ws_scheme_sca
 
-       USE kinds
+       USE kinds  
 
        USE bulk_cloud_model_mod,                                               &
            ONLY: bulk_cloud_model, microphysics_morrison, microphysics_seifert
 
+       USE salsa_util_mod,                                                     &
+           ONLY:  sums_salsa_ws_l            
+           
        USE statistics,                                                         &
            ONLY:  sums_us2_ws_l, sums_vs2_ws_l, sums_ws2_ws_l, sums_wsncs_ws_l,&
                   sums_wsnrs_ws_l, sums_wspts_ws_l, sums_wsqcs_ws_l,           &
                   sums_wsqrs_ws_l, sums_wsqs_ws_l, sums_wsss_ws_l,             &
-                  sums_wssas_ws_l, sums_wsus_ws_l, sums_wsvs_ws_l      
+                  sums_wssas_ws_l, sums_wsus_ws_l, sums_wsvs_ws_l
                    
 
@@ -1134,5 +1147,8 @@
           ENDIF
           IF ( ocean_mode )  sums_wssas_ws_l = 0.0_wp
-
+       
+          sums_salsa_ws_l = 0.0_wp
+         
+          
        ENDIF
 
@@ -1167,8 +1183,11 @@
        USE pegrid
 
+       USE salsa_util_mod,                                                     &
+           ONLY:  sums_salsa_ws_l   
+
        USE statistics,                                                         &
            ONLY:  hom, sums_wsncs_ws_l, sums_wsnrs_ws_l, sums_wspts_ws_l,      &
                   sums_wsqcs_ws_l,  sums_wsqrs_ws_l, sums_wsqs_ws_l,           &
-                  sums_wssas_ws_l, sums_wsss_ws_l, weight_substep    
+                  sums_wssas_ws_l, sums_wsss_ws_l, weight_substep
                   
 
@@ -1704,4 +1723,15 @@
                     ) * weight_substep(intermediate_timestep_count)
              ENDDO
+                  
+         CASE ( 'aerosol_mass', 'aerosol_number', 'salsa_gas' )
+         
+             DO  k = nzb, nzt
+                sums_salsa_ws_l(k,tn)  = sums_salsa_ws_l(k,tn) +               &
+                    ( flux_t(k) / ( w(k,j,i) + SIGN( 1.0E-20_wp, w(k,j,i) ) )  &
+                                * ( w(k,j,i) - hom(k,1,3,0)                 )  &
+                    + diss_t(k) / ( ABS(w(k,j,i)) + 1.0E-20_wp              )  &
+                                *   ABS( w(k,j,i) - hom(k,1,3,0)            )  &
+                    ) * weight_substep(intermediate_timestep_count)
+             ENDDO             
 
 !          CASE ( 'kc' )
@@ -3211,4 +3241,7 @@
            
        USE kinds
+       
+       USE salsa_util_mod,                                                     &
+           ONLY:  sums_salsa_ws_l      
        
        USE statistics,                                                         &
@@ -3731,5 +3764,17 @@
                                 *   ABS(w(k,j,i) - hom(k,1,3,0)             )  &
                             ) * weight_substep(intermediate_timestep_count)
-                    ENDDO   
+                    ENDDO  
+     
+                 CASE ( 'aerosol_mass', 'aerosol_number', 'salsa_gas' )
+                     DO  k = nzb, nzt
+                        sums_salsa_ws_l(k,tn)  = sums_salsa_ws_l(k,tn)         &
+                          + ( flux_t(k)                                        &
+                                / ( w(k,j,i) + SIGN( 1.0E-20_wp, w(k,j,i) ) )  &
+                                * ( w(k,j,i) - hom(k,1,3,0)                 )  &
+                            + diss_t(k)                                        &
+                                / ( ABS(w(k,j,i)) + 1.0E-20_wp              )  &
+                                *   ABS(w(k,j,i) - hom(k,1,3,0)             )  &
+                            ) * weight_substep(intermediate_timestep_count)
+                     ENDDO                    
                                    
 
Index: /palm/trunk/SOURCE/average_3d_data.f90
===================================================================
--- /palm/trunk/SOURCE/average_3d_data.f90	(revision 3466)
+++ /palm/trunk/SOURCE/average_3d_data.f90	(revision 3467)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Implementation of a new aerosol module salsa. 
+! 
+! 3448 2018-10-29 18:14:31Z kanani
 ! Adjustment of biometeorology calls
 ! 
@@ -71,5 +74,5 @@
 ! Implementation of new microphysic scheme: cloud_scheme = 'morrison' 
 ! includes two more prognostic equations for cloud drop concentration (nc)  
-! and cloud water content (qc). 
+! and cloud water content (qc).  
 ! 
 ! 2233 2017-05-30 18:08:54Z suehring
@@ -188,4 +191,7 @@
     USE radiation_model_mod,                                                   &
         ONLY:  radiation, radiation_3d_data_averaging
+           
+    USE salsa_mod,                                                             &
+        ONLY:  salsa, salsa_3d_data_averaging 
 
     USE turbulence_closure_mod,                                                &
@@ -569,4 +575,8 @@
                 CALL radiation_3d_data_averaging( 'average', doav(ii) )
              ENDIF
+             
+             IF ( salsa )  THEN
+                CALL salsa_3d_data_averaging( 'average', doav(ii) )
+             ENDIF             
 
              IF ( biometeorology )  THEN
Index: /palm/trunk/SOURCE/boundary_conds.f90
===================================================================
--- /palm/trunk/SOURCE/boundary_conds.f90	(revision 3466)
+++ /palm/trunk/SOURCE/boundary_conds.f90	(revision 3467)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Implementation of a new aerosol module salsa.
+! 
+! 3347 2018-10-15 14:21:08Z suehring
 ! Bugfix in setting boundary conditions in offline nesting
 ! 
@@ -240,4 +243,7 @@
     USE pmc_interface,                                                         &
         ONLY : nesting_mode, rans_mode_parent
+ 
+    USE salsa_mod,                                                             &
+        ONLY:  salsa, salsa_boundary_conds        
 
     USE surface_mod,                                                           &
@@ -1373,4 +1379,8 @@
 
     ENDIF
+    
+    IF ( salsa )  THEN
+       CALL salsa_boundary_conds
+    ENDIF 
 
  END SUBROUTINE boundary_conds
Index: /palm/trunk/SOURCE/check_parameters.f90
===================================================================
--- /palm/trunk/SOURCE/check_parameters.f90	(revision 3466)
+++ /palm/trunk/SOURCE/check_parameters.f90	(revision 3467)
@@ -20,5 +20,7 @@
 ! Current revisions:
 ! -----------------
-! 
+!
+! 2017-10-10 11:29:14Z monakurppa
+! Implementation of a new aerosol module salsa.
 ! 
 ! Former revisions:
@@ -781,4 +783,7 @@
         ONLY:  radiation, radiation_check_data_output,                         &
                radiation_check_data_output_pr, radiation_check_parameters
+                            
+    USE salsa_mod,                                                             &
+        ONLY:  salsa, salsa_check_data_output, salsa_check_parameters        
 
     USE spectra_mod,                                                           &
@@ -1514,4 +1519,7 @@
 !-- Checks for surface data output
     IF ( surface_data_output )  CALL surface_output_check_parameters
+!    
+!-- When SALSA is used, perform additional checks 
+    IF ( salsa )  CALL salsa_check_parameters     
 
 !
@@ -3214,4 +3222,8 @@
              ENDIF
 
+             IF ( unit == 'illegal' .AND. salsa ) THEN
+                 CALL salsa_check_data_output( var, unit )
+             ENDIF   
+
              IF ( unit == 'illegal'  .AND.  urban_surface                      &
                                      .AND.  var(1:4) == 'usm_' )  THEN
Index: /palm/trunk/SOURCE/chem_emissions_mod.f90
===================================================================
--- /palm/trunk/SOURCE/chem_emissions_mod.f90	(revision 3466)
+++ /palm/trunk/SOURCE/chem_emissions_mod.f90	(revision 3467)
@@ -27,4 +27,8 @@
 ! -----------------
 ! $Id$
+! Enabled PARAMETRIZED mode for default surfaces when LSM is not applied but 
+! salsa is used
+! 
+! 3458 2018-10-30 14:51:23Z kanani
 ! from chemistry branch r3443, banzhafs, Russo:
 ! Additional correction for index of input file of pre-processed mode
@@ -885,4 +889,6 @@
    USE indices,                                                               &
        ONLY: nnx,nny,nnz 
+   USE salsa_mod,                                                             &
+       ONLY:  salsa
    USE surface_mod,                                                           &
        ONLY:  surf_lsm_h,surf_def_h,surf_usm_h
@@ -1366,5 +1372,5 @@
 
        !> Streets are lsm surfaces, hence, no usm surface treatment required
-             IF (surf_lsm_h%ns .GT. 0) THEN
+             IF (surf_lsm_h%ns .GT. 0 ) THEN
                 DO  m = 1, surf_lsm_h%ns
                    i = surf_lsm_h%i(m)
@@ -1442,4 +1448,73 @@
                    !> If no street type is defined, then assign null emissions to all the species
                       surf_lsm_h%cssws(:,m) = 0.0_wp
+
+                   ENDIF
+
+                ENDDO
+             ELSEIF ( salsa ) THEN
+                DO  m = 1, surf_def_h(0)%ns
+                   i = surf_def_h(0)%i(m)
+                   j = surf_def_h(0)%j(m)
+                   k = surf_def_h(0)%k(m)
+
+
+                   IF ( street_type_f%var(j,i) >= main_street_id  .AND.        &
+                        street_type_f%var(j,i) < max_street_id )               &
+                   THEN
+
+                      !> Cycle over already matched species
+                      DO  ispec=1,nspec_out
+
+                         !> PMs are already in mass units:micrograms: have to be converted to kilograms 
+                         IF ( TRIM(spc_names(match_spec_model(ispec)))=="PM1"       &
+                              .OR. TRIM(spc_names(match_spec_model(ispec)))=="PM25" &
+                              .OR. TRIM(spc_names(match_spec_model(ispec)))=="PM10")&
+                         THEN
+                                  
+                            surf_def_h(0)%cssws(match_spec_model(ispec),m) =   &
+                                  emiss_factor_main(match_spec_input(ispec)) * &
+                                  emis_distribution(1,j,i,ispec) * rho_air(k) /&
+                                  time_factor(1)
+                         ELSE
+
+                         !> Other Species: inputs are micromoles: have to be converted              
+                            surf_def_h(0)%cssws(match_spec_model(ispec),m) =   &
+                               emiss_factor_main(match_spec_input(ispec)) *    &
+                               emis_distribution(1,j,i,ispec) *                &
+                               conv_to_ratio(k,j,i) *  rho_air(k) / time_factor(1)
+                         ENDIF
+                      ENDDO
+
+                   ELSEIF ( street_type_f%var(j,i) >= side_street_id  .AND.    &
+                            street_type_f%var(j,i) < main_street_id )          &
+                   THEN
+
+                   !> Cycle over already matched species
+                      DO  ispec=1,nspec_out
+
+                         !> PMs are already in mass units: micrograms
+                         IF ( TRIM(spc_names(match_spec_model(ispec)))=="PM1"   &
+                              .OR. TRIM(spc_names(match_spec_model(ispec)))=="PM25" &
+                              .OR. TRIM(spc_names(match_spec_model(ispec)))=="PM10")&
+                         THEN
+
+                            surf_def_h(0)%cssws(match_spec_model(ispec),m) =   &
+                               emiss_factor_side(match_spec_input(ispec)) *    &
+                               emis_distribution(1,j,i,ispec) * rho_air(k) /   &
+                               time_factor(1)  
+                         ELSE
+               
+                            surf_def_h(0)%cssws(match_spec_model(ispec),m) =   &
+                               emiss_factor_side(match_spec_input(ispec)) *    &
+                               emis_distribution(1,j,i,ispec) *                &
+                               conv_to_ratio(k,j,i) * rho_air(k) / time_factor(1)
+                         ENDIF
+
+                      ENDDO
+
+                   ELSE
+
+                   !> If no street type is defined, then assign null emissions to all the species
+                      surf_def_h(0)%cssws(:,m) = 0.0_wp
 
                    ENDIF
Index: /palm/trunk/SOURCE/data_output_2d.f90
===================================================================
--- /palm/trunk/SOURCE/data_output_2d.f90	(revision 3466)
+++ /palm/trunk/SOURCE/data_output_2d.f90	(revision 3467)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Implementation of a new aerosol module salsa.
+! 
+! 3448 2018-10-29 18:14:31Z kanani
 ! Add biometeorology
 ! 
@@ -314,4 +317,7 @@
     USE radiation_model_mod,                                                   &
         ONLY:  radiation, radiation_data_output_2d
+   
+    USE salsa_mod,                                                             &
+        ONLY:  salsa, salsa_data_output_2d    
 
     USE surface_mod,                                                           &
@@ -1338,9 +1344,9 @@
                                                   nzb_do, nzt_do  )
                 ENDIF
-
-                IF ( .NOT. found )  THEN
-                   CALL tcm_data_output_2d( av, do2d(av,if), found, grid, mode,&
-                                             local_pf, nzb_do, nzt_do )
-                ENDIF
+                
+                IF ( .NOT. found  .AND.  salsa )  THEN
+                   CALL salsa_data_output_2d( av, do2d(av,if), found, grid,    &
+                                              mode, local_pf, two_d )
+                ENDIF                 
 
                 IF ( .NOT. found  .AND.  uv_exposure )  THEN
Index: /palm/trunk/SOURCE/data_output_3d.f90
===================================================================
--- /palm/trunk/SOURCE/data_output_3d.f90	(revision 3466)
+++ /palm/trunk/SOURCE/data_output_3d.f90	(revision 3467)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Implementation of a new aerosol module salsa.
+! 
+! 3448 2018-10-29 18:14:31Z kanani
 ! Adjustment of biometeorology calls
 ! 
@@ -291,4 +294,7 @@
     USE radiation_model_mod,                                                   &
         ONLY:  nzub, nzut, radiation, radiation_data_output_3d
+               
+    USE salsa_mod,                                                             &
+        ONLY:  salsa, salsa_data_output_3d     
 
     USE turbulence_closure_mod,                                                &
@@ -775,4 +781,11 @@
                 resorted = .TRUE.
              ENDIF
+             
+!
+!--          SALSA output
+             IF ( .NOT. found  .AND.  salsa )  THEN
+                CALL salsa_data_output_3d( av, do3d(av,if), found, local_pf )
+                resorted = .TRUE.
+             ENDIF                  
 
              IF ( .NOT. found  .AND.  biometeorology )  THEN
Index: /palm/trunk/SOURCE/data_output_mask.f90
===================================================================
--- /palm/trunk/SOURCE/data_output_mask.f90	(revision 3466)
+++ /palm/trunk/SOURCE/data_output_mask.f90	(revision 3467)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Implementation of a new aerosol module salsa.
+! 
+! 3435 2018-10-26 18:25:44Z gronemeier
 ! Add terrain-following output
 ! 
@@ -186,6 +189,9 @@
         ONLY:  radiation, radiation_data_output_mask
 
+    USE salsa_mod,                                                             &
+        ONLY:  salsa, salsa_data_output_mask     
+        
     USE surface_mod,                                                           &
-        ONLY :  surf_def_h, surf_lsm_h, surf_usm_h, get_topography_top_index_ji
+        ONLY :  surf_def_h, surf_lsm_h, surf_usm_h, get_topography_top_index_ji      
 
     IMPLICIT NONE
@@ -665,4 +671,10 @@
              ENDIF
 !
+!--          SALSA quantities
+             IF (  salsa )  THEN
+                CALL salsa_data_output_mask( av, domask(mid,av,ivar), found,   &
+                                             local_pf )
+             ENDIF         
+!
 !--          User defined quantity
              IF ( .NOT. found )  THEN
